package com.zhentao.controller;

import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.AuthenticationException;
import org.apache.shiro.authc.IncorrectCredentialsException;
import org.apache.shiro.authc.UnknownAccountException;
import org.apache.shiro.authc.UsernamePasswordToken;
import org.apache.shiro.subject.Subject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
public class LoginController {

    @PostMapping("/login")
    public String login(@RequestParam String username, @RequestParam String password) {
        Subject currentUser = SecurityUtils.getSubject();
        UsernamePasswordToken token = new UsernamePasswordToken(username, password);
        try {
            currentUser.login(token);
            return "redirect:/home";
        } catch (UnknownAccountException e) { // 用户名不存在
            return "redirect:/login?error=invalid";
        } catch (IncorrectCredentialsException e) { // 密码错误
            return "redirect:/login?error=invalid";
        } catch (AuthenticationException e) { // 其他认证异常（如账户锁定）
            return "redirect:/login?error=unknown";
        }
    }
}